void callnullfunc() {
//    printf("nullfunc\n");
};

int addcall(struct scall **list, int id) {
    struct scall *p;
    if (!list) return 0;
    p=(struct scall *) malloc(sizeof(struct scall));
    p->list=NULL;
    p->id=id;
    if (*list == NULL) {
	*list=p;
	p->next=NULL;
    } else {
	p->next=*list;
	*list=p;
    }
    return 1;
}

int delcall(struct scall **list, int id) {
    struct scall *p, *lp;
    if (!list) return 0;
    lp=NULL;
    p=*list;
    while (p) {
	if (p->id == id) {
	    if (p->list) freecalllist(&p->list);
	    if (lp) {
		lp->next=p->next;
		free(p);
	    } else {
		*list=p->next;
		free(p);
	    }
	    return 1;
	}
	lp=p;
	p=p->next;
    }
    return 0;
}

int freecall(struct scall **list) {
    struct scall *p, *lp;
    if (!list) return 0;
    p=*list;
    while (p) {
	lp=p;
	p=p->next;
	if (lp->list) freecalllist(&lp->list);
	free(lp);
    }
    return 0;
}

int addcallid(struct scall **list, int id, char *name, Function f) {
    struct scall *p;
    struct scalllist *pl;
    if (!list) return 0;
    if (!name) return 0;
    if (!name[0]) return 0;
    if (strlen(name) >= MAXCALLNAMELEN) return 0;
    if (!f) return 0;
    p=*list;
    while (p) {
	if (p->id == id) {
	    pl=(struct scalllist *) malloc(sizeof(struct scalllist));
	    pl->f=f;
	    strcpy(pl->name, name);
	    if (p->list == NULL) {
		p->list=pl;
		pl->next=NULL;
	    } else {
		pl->next=p->list;
		p->list=pl;
	    }
	    return 1;
	}
	p=p->next;
    }
    return 0;
}

int addcallidlist(struct scall **list, int id, struct scalllistlist *clist) {
    struct scalllistlist *p;
    int ret;
    if (!clist) return 0;
    if (!clist->name || !clist->f) return 0;
    p=clist;
    ret=0;
    while (p->name && p->f) {
	if (addcallid(list, id, p->name, p->f)) ret++;
	p++;
    }
    return ret;
}

int delcallid(struct scall **list, int id, char *name) {
    struct scall *p;
    struct scalllist *pl, *lpl;
    if (!list) return 0;
    if (!name) return 0;
    if (!name[0]) return 0;
    if (strlen(name) >= MAXCALLNAMELEN) return 0;
    p=*list;
    while (p) {
	if (p->id == id) {
	    lpl=NULL;
	    pl=p->list;
	    while (pl) {
		if (strcasecmp(pl->name, name) == 0) {
		    if (lpl) {
			lpl->next=pl->next;
			free(pl);
		    } else {
			p->list=pl->next;
			free(pl);
		    }
		    return 1;
		}
		lpl=pl;
		pl=pl->next;
	    }
	}
	p=p->next;
    }
    return 0;
}

int delcallidlist(struct scall **list, int id, struct scalllistlist *clist) {
    struct scalllistlist *p;
    p=clist;
    while (p->name && p->f) {
	delcallid(list, id, p->name);
	p++;
    }
    return 1;
}

int freecallid(struct scall **list, int id) {
    struct scall *p;
    struct scalllist *pl, *lpl;
    if (!list) return 0;
    p=*list;
    while (p) {
	if (p->id == id) {
	    pl=p->list;
	    while (pl) {
		lpl=pl;
		pl=pl->next;
		free(lpl);
	    }
	    return 1;
	}
    }
    return 0;
}

int freecalllist(struct scalllist **list) {
    struct scalllist *p, *lp;
    if (!list) return 0;
    p=*list;
    while (p) {
	lp=p;
	p=p->next;
	free(lp);
    }
    return 1;
}

Function callidname(struct scall **list, int id, char *name) {
    struct scall *p;
    struct scalllist *pl;
    if (!list) return 0;
    if (!name) return 0;
    if (!name[0]) return 0;
    if (strlen(name) >= MAXCALLNAMELEN) return 0;
    p=*list;
    while (p) {
	if (p->id == id) {
	    pl=p->list;
	    while (pl) {
		if (strcasecmp(pl->name, name) == 0) return pl->f;
		pl=pl->next;
	    }
	}
	p=p->next;
    }
    return callnullfunc;
}
