#define MAXCHANNELS 			16
#define MAXMASKLEN			256

#define CHAN_UNUSED			0x0001
#define CHAN_SENTWHO			0x0002
#define CHAN_GOTWHO			0x0004
#define CHAN_SENTMODE			0x0008
#define CHAN_GOTMODE			0x0010
#define CHAN_SENTBANLIST		0x0020
#define CHAN_GOTBANLIST			0x0040
#define CHAN_SENTEXEMPTLIST		0x0080
#define CHAN_GOTEXEMPTLIST		0x0100
#define CHAN_SENTINVITELIST		0x0200
#define CHAN_GOTINVITELIST		0x0400
#define CHAN_JOIN			0x0800

#define CHAN_C_AFTEROP			0x0001

#define USER_UNUSED			0x0001
#define USER_OP				0x0002
#define USER_HASOP			0x0004
#define USER_SENTOP			0x0008
#define USER_SENTDEOP			0x0010
#define USER_SENTKICK			0x0020
#define USER_KICK			0x0040
#define USER_HOST			0x4000
#define USER_ALREADY			0x8000

#define MODE_I				0x0001
#define MODE_K				0x0002
#define MODE_L				0x0004
#define MODE_M				0x0008
#define MODE_N				0x0010
#define MODE_P				0x0020
#define MODE_S				0x0040
#define MODE_T				0x0080

#define C_REVANGE			0
#define C_BITCH				1
#define C_AFTEROP			2
#define C_BAN				3
#define C_EXEMPT			4
#define C_INVITE			5
#define C_CHANMODE			6
#define C_JOIN				7
#define C_SERVEROP			8
#define C_SERVERMODE			9
#define C_SERVERBAN			10
#define C_SERVEREXEMPT			11
#define C_SERVERINVITE			12

#define CS_NONE				0x0000
#define CS_DEOP				0x0001
#define CS_DEOPVICTIM			0x0002
#define CS_KICK				0x0004
#define CS_KICKVICTIM			0x0008
#define CS_REMOVE			0x0010
#define CS_MASSDEOP			0x0020
#define CS_MASSKICKOP			0x0040
#define CS_MASSKICKALL			0x0080
#define CS_MASSKICKMASK			0x0100
#define CS_SET_I			0x0200
#define CS_SET_K			0x0400
#define CS_BAN				0x0800
#define CS_BANVICTIM			0x1000

struct smasklist {
    char *mask;
    struct smasklist *next;
};

struct suser {
    char nick[10];
    char *host;
    int flags;
    struct shandle *handle;
    struct suser *next;
};

struct schannel {
    int flags;
    int cflags;
    int csettings[32];
    int cmdcount;
    char *name;
    char *topic;
    char *key;
    char *topicprot;
    char *keyprot;
    int mode;
    int modeprotp;
    int modeprotm;
    int limit;
    int conchan;
    int copped;
    int crejoin;
    int cjoin;
    int cunjoin;
    int onchan;
    int opped;
    struct smasklist *bans;
    struct smasklist *invites;
    struct smasklist *exempts;
    struct smasklist *bansprot;
    struct smasklist *invitesprot;
    struct smasklist *exemptsprot;
    struct suser *usersfirst;
    struct suser *userslast;
};

struct schannel chantab[MAXCHANNELS];

struct skick {
    int cid;
    int cloneid;
    char nick[10];
    struct skick *next;
};

struct smode {
    int cid;
    int cloneid;
    char pm;
    char mode;
    char *what;
    struct smode *next;
};

struct sinvite {
    int cid;
    int cloneid;
    char nick[10];
    struct sinvite *next;
};

struct skick *kicklist=NULL;
struct smode *modelist=NULL;
struct sinvite *invitelist=NULL;
