// console.c
#define MAXCONSOLEMSGLEN		1024

void console_status(int fd) {
    dprintf(fd, "[%d:%d]> ", clonesstats.connect+clonesstats.connected, clonesstats.registered);
}

int checkpass(char *nick, char *pass) {
    struct shandle *hand;
    hand=ulfindhandle(nick);
    if (!hand) return 0;
    if (!hand->pass) return 0;
    if (!hand->pass[0]) return 0;
    if (strcmp(pass, hand->pass)) return 0;
    return 1;
}

void con_quit(struct ssock *sock, struct sconsolespecial *cs, char *msg) {
    dprintf(sock->fd, "Bye!\n");
    socket_closefd(sock->fd);
}

void con_die(struct ssock *sock, struct sconsolespecial *cs, char *msg) {
    char s[MAXCONSOLEMSGLEN];
    sprintf(s, "#%s# die\n", cs->nick);
    sendconsole(s);
    shtdown=1;
}

void con_connect(struct ssock *sock, struct sconsolespecial *cs, char *msg) {
    char s[MAXCONSOLEMSGLEN];
    int i, cnt;
    cnt=atoi(newsplit(&msg));
    if (!cnt) return;
    sprintf(s, "#%s# connect %d\n", cs->nick, cnt);
    sendconsole(s);
    for (i=0; i < cnt; i++) addclone(getnextnick(), getnexthost());
}

void con_disconnect(struct ssock *sock, struct sconsolespecial *cs, char *msg) {
    char s[MAXCONSOLEMSGLEN];
    int i, j, ok, cnt;
    cnt=atoi(newsplit(&msg));
    if (!cnt) return;
    sprintf(s, "#%s# disconnect %d\n", cs->nick, cnt);
    sendconsole(s);
    i=cnt;
    ok=1;
    while (i && ok) {
	ok=0;
	for (j=0; j < MAXCLONES; j++) if (clonetab[j].status == CLONE_DISCONNECTED) {
	    delcloneid(j);
	    ok=1;
	    break;
	}
	if (!ok) {
	    for (j=0; j < MAXCLONES; j++) if (clonetab[j].status == CLONE_CONNECT) {
		delcloneid(j);
		ok=1;
		break;
	    }
	}
	if (!ok) {
	    for (j=0; j < MAXCLONES; j++) if (clonetab[j].status == CLONE_CONNECTED) {
		delcloneid(j);
		ok=1;
		break;
	    }
	}
	if (!ok) {
	    for (j=0; j < MAXCLONES; j++) if (clonetab[j].status == CLONE_REGISTERED) {
		delcloneid(j);
		ok=1;
		break;
	    }
	}
	i--;
    }
}

void con_join(struct ssock *sock, struct sconsolespecial *cs, char *msg) {
    char s[MAXCONSOLEMSGLEN];
    int i, chanid;
    char *chan;
    chan=newsplit(&msg);
    if (msg[0]) {
	chanid=addchan(chan, msg, 0);
	sprintf(s, "#%s# join %s %s\n", cs->nick, chan, msg);
    } else {
	chanid=addchan(chan, NULL, 0);
	sprintf(s, "#%s# join %s\n", cs->nick, chan);
    }
    sendconsole(s);
    if (chanid < 0) return;
    enablejoinchanid(chanid);
    clonesjoinchanid(chanid);
}

void con_joinmd(struct ssock *sock, struct sconsolespecial *cs, char *msg) {
    char s[MAXCONSOLEMSGLEN];
    int i, chanid;
    char *chan;
    chan=newsplit(&msg);
    if (msg[0]) {
	chanid=addchan(chan, msg, CHAN_C_AFTEROP);
	sprintf(s, "#%s# joinmd %s %s\n", cs->nick, chan, msg);
    } else {
	chanid=addchan(chan, NULL, CHAN_C_AFTEROP);
	sprintf(s, "#%s# joinmd %s\n", cs->nick, chan);
    }
    sendconsole(s);
    if (chanid < 0) return;
    chantab[chanid].csettings[C_AFTEROP]=CS_MASSDEOP;
    enablejoinchanid(chanid);
    clonesjoinchanid(chanid);
}

void con_joinmk(struct ssock *sock, struct sconsolespecial *cs, char *msg) {
    char s[MAXCONSOLEMSGLEN];
    int i, chanid;
    char *chan;
    chan=newsplit(&msg);
    if (msg[0]) {
	chanid=addchan(chan, msg, CHAN_C_AFTEROP);
	sprintf(s, "#%s# joinmk %s %s\n", cs->nick, chan, msg);
    } else {
	chanid=addchan(chan, NULL, CHAN_C_AFTEROP);
	sprintf(s, "#%s# joinmk %s\n", cs->nick, chan);
    }
    sendconsole(s);
    if (chanid < 0) return;
    chantab[chanid].csettings[C_AFTEROP]=CS_MASSKICKOP;
    enablejoinchanid(chanid);
    clonesjoinchanid(chanid);
}

void con_part(struct ssock *sock, struct sconsolespecial *cs, char *msg) {
    char s[MAXCONSOLEMSGLEN];
    int i;
    char *chan;
    chan=newsplit(&msg);
    sprintf(s, "#%s# part %s\n", cs->nick, chan);
    sendconsole(s);
    clonespartchanname(chan);
    delchanname(chan);
}

void con_op(struct ssock *sock, struct sconsolespecial *cs, char *msg) {
    char s[MAXCONSOLEMSGLEN];
    int i, ret, cid;
    struct suser *p;
    char *chan;
    char *nick;
    chan=newsplit(&msg);
    cid=findchanname(chan);
    if (cid < 0) {
	dprintf(sock->fd, "No such channel %s.\n", chan);
	return;
    }
    if (!chantab[cid].copped) {
	dprintf(sock->fd, "No opped clones on %s.\n", chan);
	return;
    }
    sprintf(s, "#%s# op %s %s\n", cs->nick, chan, msg);
    sendconsole(s);
    nick=newsplit(&msg);
    while (nick && nick[0]) {
	if ((p=findchanuserid(cid, nick)))
	    if (!(p->flags & USER_HASOP)) addchanmodeid(cid, '+', 'o', nick);
	nick=newsplit(&msg);
    }
}

void con_deop(struct ssock *sock, struct sconsolespecial *cs, char *msg) {
    char s[MAXCONSOLEMSGLEN];
    int i, ret, cid;
    struct suser *p;
    char *chan;
    char *nick;
    chan=newsplit(&msg);
    cid=findchanname(chan);
    if (cid < 0) {
	dprintf(sock->fd, "No such channel %s.\n", chan);
	return;
    }
    if (!chantab[cid].copped) {
	dprintf(sock->fd, "No opped clones on %s.\n", chan);
	return;
    }
    sprintf(s, "#%s# deop %s %s\n", cs->nick, chan, msg);
    sendconsole(s);
    nick=newsplit(&msg);
    while (nick && nick[0]) {
	if ((p=findchanuserid(cid, nick)) && !isclonenick(nick))
	    if (p->flags & USER_HASOP) addchanmodeid(cid, '-', 'o', nick);
	nick=newsplit(&msg);
    }
}

void con_massop(struct ssock *sock, struct sconsolespecial *cs, char *msg) {
    char s[MAXCONSOLEMSGLEN];
    int i, ret, cid;
    struct suser *p;
    char *chan;
    char *nick;
    chan=newsplit(&msg);
    cid=findchanname(chan);
    if (cid < 0) {
	dprintf(sock->fd, "No such channel %s.\n", chan);
	return;
    }
    if (!chantab[cid].copped) {
	dprintf(sock->fd, "No opped clones on %s.\n", chan);
	return;
    }
    sprintf(s, "#%s# massop %s\n", cs->nick, chan);
    sendconsole(s);
    p=chantab[cid].usersfirst;
    while (p) {
	if (!isclonenick(p->nick))
	    if (!(p->flags & USER_OP)) addchanmodeid(cid, '+', 'o', p->nick);
	p=p->next;
    }
}

void con_massdeop(struct ssock *sock, struct sconsolespecial *cs, char *msg) {
    char s[MAXCONSOLEMSGLEN];
    int i, ret, cid;
    struct suser *p;
    char *chan;
    struct suser *u;
    chan=newsplit(&msg);
    cid=findchanname(chan);
    if (cid < 0) {
	dprintf(sock->fd, "No such channel %s.\n", chan);
	return;
    }
    if (!chantab[cid].copped) {
	dprintf(sock->fd, "No opped clones on %s.\n", chan);
	return;
    }
    sprintf(s, "#%s# massdeop %s\n", cs->nick, chan);
    sendconsole(s);
    p=chantab[cid].usersfirst;
    while (p) {
	if (!isclonenick(p->nick)) {
	    u=findchanuserid(cid, p->nick);
	    if (u) if (!ULMATCHFLAG(u->handle, 'o') && p->flags & USER_OP) addchanmodeid(cid, '-', 'o', p->nick);
	}
	p=p->next;
    }
}

void con_masskick(struct ssock *sock, struct sconsolespecial *cs, char *msg) {
    char s[MAXCONSOLEMSGLEN];
    int i, ret, cid;
    struct suser *p;
    char *chan;
    struct suser *u;
    chan=newsplit(&msg);
    cid=findchanname(chan);
    if (cid < 0) {
	dprintf(sock->fd, "No such channel %s.\n", chan);
	return;
    }
    if (!chantab[cid].copped) {
	dprintf(sock->fd, "No opped clones on %s.\n", chan);
	return;
    }
    sprintf(s, "#%s# masskick %s\n", cs->nick, chan);
    sendconsole(s);
    p=chantab[cid].usersfirst;
    while (p) {
	if (!isclonenick(p->nick)) {
	    u=findchanuserid(cid, p->nick);
	    if (u) if (!ULMATCHFLAG(u->handle, 'o')) addchankickid(cid, p->nick);
	}
	p=p->next;
    }
}

void con_masskickop(struct ssock *sock, struct sconsolespecial *cs, char *msg) {
    char s[MAXCONSOLEMSGLEN];
    int i, ret, cid;
    struct suser *p;
    char *chan;
    struct suser *u;
    chan=newsplit(&msg);
    cid=findchanname(chan);
    if (cid < 0) {
	dprintf(sock->fd, "No such channel %s.\n", chan);
	return;
    }
    if (!chantab[cid].copped) {
	dprintf(sock->fd, "No opped clones on %s.\n", chan);
	return;
    }
    sprintf(s, "#%s# masskickop %s\n", cs->nick, chan);
    sendconsole(s);
    p=chantab[cid].usersfirst;
    while (p) {
	if (!isclonenick(p->nick)) {
	    u=findchanuserid(cid, p->nick);
	    if (u) if (!ULMATCHFLAG(u->handle, 'o') && p->flags & USER_OP) addchankickid(cid, p->nick);
	}
	p=p->next;
    }
}

void con_invite(struct ssock *sock, struct sconsolespecial *cs, char *msg) {
    char s[MAXCONSOLEMSGLEN];
    int i, ret, cid;
    struct suser *p;
    char *chan;
    char *nick;
    chan=newsplit(&msg);
    cid=findchanname(chan);
    if (cid < 0) {
	dprintf(sock->fd, "No such channel %s.\n", chan);
	return;
    }
    if (!chantab[cid].copped) {
	dprintf(sock->fd, "No opped clones on %s.\n", chan);
	return;
    }
    sprintf(s, "#%s# invite %s %s\n", cs->nick, chan, msg);
    sendconsole(s);
    nick=newsplit(&msg);
    while (nick && nick[0]) {
	if (findchanuserid(cid, nick) == NULL) addchaninviteid(cid, nick);
	nick=newsplit(&msg);
    }
}

void con_listchan(struct ssock *sock, struct sconsolespecial *cs, char *msg) {
    int i, ret, cid;
    char *chan;
    struct suser *p;
    chan=newsplit(&msg);
    cid=findchanname(chan);
    if (cid < 0) {
	dprintf(sock->fd, "No such channel %s.\n", chan);
	return;
    }
    dprintf(sock->fd, "#%s# listchan %s\n", cs->nick, chan);
    p=chantab[cid].usersfirst;
    while (p) {
	if (p->handle) {
	    dprintf(sock->fd, "%c%s (%s) %s\n", (p->flags & USER_OP)?'@':' ', p->nick, p->host, p->handle->handle);
	} else {
	    dprintf(sock->fd, "%c%s (%s) -\n", (p->flags & USER_OP)?'@':' ', p->nick, p->host);
	}
	p=p->next;
    }
}

void con_chanstats(struct ssock *sock, struct sconsolespecial *cs, char *msg) {
    struct smode *p;
    int i, ret, cid;
    char *chan;
    chan=newsplit(&msg);
    cid=findchanname(chan);
    if (cid < 0) {
	dprintf(sock->fd, "No such channel %s.\n", chan);
	return;
    }
    dprintf(sock->fd, "#%s# chanstats %s\n", cs->nick, chan);
    dprintf(sock->fd, "Statistics for %s\n", chan);
    dprintf(sock->fd, "On chan: %d\n", chantab[cid].onchan);
    dprintf(sock->fd, "Clones on chan: %d\n", chantab[cid].conchan);
    dprintf(sock->fd, "Opped: %d\n", chantab[cid].opped);
    dprintf(sock->fd, "Clones opped: %d\n", chantab[cid].copped);
    dprintf(sock->fd, "Rejoin: %d\n", chantab[cid].crejoin);
    dprintf(sock->fd, "Join: %d\n", chantab[cid].cjoin);
}

void con_chancnt(struct ssock *sock, struct sconsolespecial *cs, char *msg) {
    int i, ret, cid;
    char *chan;
    chan=newsplit(&msg);
    cid=findchanname(chan);
    if (cid < 0) {
	dprintf(sock->fd, "No such channel %s.\n", chan);
	return;
    }
    dprintf(sock->fd, "#%s# chancnt %s\n", cs->nick, chan);
    dprintf(sock->fd, "%s %d\n", chan, chantab[cid].cmdcount);
    for (i=0; i < MAXCLONES; i++) if (clonetab[i].status == CLONE_REGISTERED) {
	dprintf(sock->fd, "%s %d %s\n", clonetab[i].nick, clonetab[i].channels[cid].cmdcount, (clonetab[i].channels[cid].flags & CLONE_CHAN_SYNCHED)?"yes":"no");
    }
}

void con_chaninfo(struct ssock *sock, struct sconsolespecial *cs, char *msg) {
    int i, ret, cid;
    char *chan, *flags;
    struct smasklist *p;
    chan=newsplit(&msg);
    cid=findchanname(chan);
    if (cid < 0) {
	dprintf(sock->fd, "No such channel %s.\n", chan);
	return;
    }
    dprintf(sock->fd, "#%s# chaninfo %s\n", cs->nick, chan);
    dprintf(sock->fd, "cflags: %d\n", chantab[cid].cflags);
    dprintf(sock->fd, "Topic: %s\n", chantab[cid].topic);
    dprintf(sock->fd, "Key: %s\n", chantab[cid].key);
    dprintf(sock->fd, "Topic prot: %s\n", chantab[cid].topicprot);
    dprintf(sock->fd, "Key prot: %s\n", chantab[cid].keyprot);
    dprintf(sock->fd, "Chanmode: %d\n", chantab[cid].mode);
    dprintf(sock->fd, "Limit: %d\n", chantab[cid].limit);
    dprintf(sock->fd, "Clones on chan: %d\n", chantab[cid].conchan);
    dprintf(sock->fd, "Clones opped: %d\n", chantab[cid].copped);
    dprintf(sock->fd, "Clones join: %d\n", chantab[cid].cjoin);
    dprintf(sock->fd, "Clones unable to join: %d\n", chantab[cid].cunjoin);
    dprintf(sock->fd, "Users on chan: %d\n", chantab[cid].onchan);
    dprintf(sock->fd, "Ops on chan: %d\n", chantab[cid].opped);
    dprintf(sock->fd, "Bans:\n");
    p=chantab[cid].bans;
    while (p) {
	dprintf(sock->fd, "%s\n", p->mask);
	p=p->next;
    }					
    dprintf(sock->fd, "Exempts:\n");
    p=chantab[cid].exempts;
    while (p) {
	dprintf(sock->fd, "%s\n", p->mask);
	p=p->next;
    }					
    dprintf(sock->fd, "Invites:\n");
    p=chantab[cid].invites;
    while (p) {
	dprintf(sock->fd, "%s\n", p->mask);
	p=p->next;
    }					
}

void con_chansettings(struct ssock *sock, struct sconsolespecial *cs, char *msg) {
    int i, ret, cid;
    char *chan;
    chan=newsplit(&msg);
    cid=findchanname(chan);
    if (cid < 0) {
	dprintf(sock->fd, "No such channel %s.\n", chan);
	return;
    }
    dprintf(sock->fd, "#%s# chansettings %s\n", cs->nick, chan);
    for (i=0; i < MAXCLONES; i++) if (clonetab[i].status == CLONE_REGISTERED) {
	dprintf(sock->fd, "%s %x\n", clonetab[i].nick, clonetab[i].channels[cid].flags);
    }
}

void con_plususer(struct ssock *sock, struct sconsolespecial *cs, char *msg) {
    char s[MAXCONSOLEMSGLEN];
    char *nick;
    nick=newsplit(&msg);
    if (!nick || !nick[0]) return;
    if (ulfindhandle(nick)) {
	dprintf(sock->fd, "%s already exists.\n", nick);
	return;
    }
    sprintf(s, "#%s# +user %s\n", cs->nick, nick);
    sendconsole(s);
    uladduser(nick);
}

void con_minususer(struct ssock *sock, struct sconsolespecial *cs, char *msg) {
    char s[MAXCONSOLEMSGLEN];
    char *nick;
    nick=newsplit(&msg);
    if (!nick || !nick[0]) return;
    if (!ulfindhandle(nick)) {
	dprintf(sock->fd, "No such user: %s.\n", nick);
	return;
    }
    sprintf(s, "#%s# -user %s\n", cs->nick, nick);
    sendconsole(s);
    uldeluser(nick);
}

void con_chattruser(struct ssock *sock, struct sconsolespecial *cs, char *msg) {
    char s[MAXCONSOLEMSGLEN];
    char *nick;
    char *attr;
    nick=newsplit(&msg);
    attr=newsplit(&msg);
    if (!nick || !nick[0]) return;
    if (!attr || !attr[0]) return;
    if (!ulfindhandle(nick)) {
	dprintf(sock->fd, "No such user: %s.\n", nick);
	return;
    }
    sprintf(s, "#%s# chattr %s %s\n", cs->nick, nick, attr);
    sendconsole(s);
    ulchattruser(nick, attr);
}

void con_chpassuser(struct ssock *sock, struct sconsolespecial *cs, char *msg) {
    char s[MAXCONSOLEMSGLEN];
    char *nick;
    char *pass;
    nick=newsplit(&msg);
    pass=newsplit(&msg);
    if (!nick || !nick[0]) return;
    if (!pass || !pass[0]) return;
    if (!ulfindhandle(nick)) {
	dprintf(sock->fd, "No such user: %s.\n", nick);
	return;
    }
    sprintf(s, "#%s# chpass %s [something]\n", cs->nick, nick);
    sendconsole(s);
    ulchpassuser(nick, pass);
}

void con_plushostuser(struct ssock *sock, struct sconsolespecial *cs, char *msg) {
    char s[MAXCONSOLEMSGLEN];
    char *nick;
    char *host;
    nick=newsplit(&msg);
    host=newsplit(&msg);
    if (!nick || !nick[0]) return;
    if (!host || !host[0]) return;
    if (!ulfindhandle(nick)) {
	dprintf(sock->fd, "No such user: %s.\n", nick);
	return;
    }
    sprintf(s, "#%s# +host %s %s\n", cs->nick, nick, host);
    sendconsole(s);
    uladdhost(nick, host);
}

void con_minushostuser(struct ssock *sock, struct sconsolespecial *cs, char *msg) {
    char s[MAXCONSOLEMSGLEN];
    char *nick;
    char *host;
    nick=newsplit(&msg);
    host=newsplit(&msg);
    if (!nick || !nick[0]) return;
    if (!host || !host[0]) return;
    if (!ulfindhandle(nick)) {
	dprintf(sock->fd, "No such user: %s.\n", nick);
	return;
    }
    sprintf(s, "#%s# -host %s %s\n", cs->nick, nick, host);
    sendconsole(s);
    uldelhost(nick, host);
}

void con_whoisuser(struct ssock *sock, struct sconsolespecial *cs, char *msg) {
    char s[MAXCONSOLEMSGLEN];
    char *nick;
    nick=newsplit(&msg);
    if (!nick || !nick[0]) return;
    if (!ulfindhandle(nick)) {
	dprintf(sock->fd, "No such user: %s.\n", nick);
	return;
    }
    sprintf(s, "#%s# whois %s\n", cs->nick, nick);
    sendconsole(s);
    ulprinthandle(sock->fd, nick);
}

void con_saveuser(struct ssock *sock, struct sconsolespecial *cs, char *msg) {
    char s[MAXCONSOLEMSGLEN];
    sprintf(s, "#%s# save\n", cs->nick);
    sendconsole(s);
    ulsave("crazycow.uf");
}

struct scalllistlist callcon[] = {
    {"quit",		&con_quit},
    {"die",		&con_die},
    {"connect",		&con_connect},
    {"c",		&con_connect},
    {"disconnect",	&con_disconnect},
    {"dc",		&con_disconnect},
    {"join",		&con_join},
    {"joinmd",		&con_joinmd},
    {"joinmk",		&con_joinmk},
    {"part",		&con_part},
    {"op",		&con_op},
    {"deop",		&con_deop},
    {"invite",		&con_invite},
    {"mo",		&con_massop},
    {"massop",		&con_massop},
    {"md",		&con_massdeop},
    {"massdeop",	&con_massdeop},
    {"mk",		&con_masskick},
    {"masskick",	&con_masskick},
    {"mko",		&con_masskickop},
    {"masskickop",	&con_masskickop},
    {"list",		&con_listchan},
    {"chanstats",	&con_chanstats},
    {"chancnt",		&con_chancnt},
    {"chaninfo",	&con_chaninfo},
    {"chansettings",	&con_chansettings},
    {"+user",		&con_plususer},
    {"-user",		&con_minususer},
    {"chattr",		&con_chattruser},
    {"chpass",		&con_chpassuser},
    {"+host",		&con_plushostuser},
    {"-host",		&con_minushostuser},
    {"whois",		&con_whoisuser},
    {"save",		&con_saveuser},
    {NULL, NULL},
};

void console_parse(char *s, struct ssock *sock) {
    char cons[MAXCONSOLEMSGLEN];
    struct sconsolespecial *p;
    char *cmd;
    char *par;
    if (!s) return;
    if (!sock) return;
    p=(struct sconsolespecial *) sock->special;
    if (!p) return;
    switch (p->status) {
    case CONSTATUS_NICK:
	if (!s[0]) return;
	p->status=CONSTATUS_PASSWORD;
	strncpy(p->nick, s, CON_MAXNICKLEN);
	p->nick[CON_MAXNICKLEN-1]=0;
	dprintf(sock->fd, "Password: ");
	break;
    case CONSTATUS_PASSWORD:
	if (!s[0]) return;
	if (!p->nick[0]) return;
	if (checkpass(p->nick, s)) {
	    p->status=CONSTATUS_CMD;
	    dprintf(sock->fd, "Logged in.\n");
	    addconsole(sock->fd);
	    sprintf(cons, "*** %s has joined.\n", p->nick);
	    sendconsole(cons);
	    console_status(sock->fd);
	} else {
	    dprintf(sock->fd, "Permission denied.\n");
	    socket_closefd(sock->fd);
	}
	break;
    case CONSTATUS_CMD:
	if (!p->nick[0]) return;
	if ((s[0] == '.') && s[1]) {
	    cmd=newsplit(&s);
	    cmd++;
	    call(CALL_CONSOLE, cmd)(sock, p, s);
	} else if (s[0]) {
	    sprintf(cons, "<%s> %s\n", p->nick, s);
	    sendconsole(cons);
	}
	console_status(sock->fd);
	break;
    default:
        socket_closefd(sock->fd);
	break;
    }
    return;
}

void console_onconnect(struct ssock *sock) {
    char s[MAXCONSOLEMSGLEN];
    struct sconsolespecial *p;
    int ip[4];
    p=(struct sconsolespecial *) malloc(sizeof(struct sconsolespecial));
    p->nick[0]=0;
    p->status=CONSTATUS_NICK;
    sock->special=(void *) p;
    dprintf(sock->fd, "CrazyCow v1.1.1\n(C) Copyright Nowak 2001\n\nLogin: ");
    ip[0]=((unsigned int) sock->sin.sin_addr.s_addr) % 0x100;
    ip[1]=((unsigned int) sock->sin.sin_addr.s_addr >> 8) % 0x100;
    ip[2]=((unsigned int) sock->sin.sin_addr.s_addr >> 16) % 0x100;
    ip[3]=((unsigned int) sock->sin.sin_addr.s_addr >> 24) % 0x100;
    sprintf(s, "*** Connection from %d.%d.%d.%d.\n", ip[0], ip[1], ip[2], ip[3]);
    sendconsole(s);
    return;
}

void console_ondisconnect(struct ssock *sock) {
    struct sconsolespecial *p;
    p=(struct sconsolespecial *) sock->special;
    return;
}

void console_onrecv(struct ssock *sock) {
    char *s;
    if (!sock) return;
    if (!sock->inbuf) return;
    parse(sock->inbuf, '\n', console_parse, sock);
    return;
}

void console_onerror(struct ssock *sock) {
    return;
}

void console_onclose(struct ssock *sock) {
    char s[MAXCONSOLEMSGLEN];
    struct sconsolespecial *p;
    p=(struct sconsolespecial *) sock->special;
    if (p) {
	if (p->nick && p->nick[0]) {
    	    sprintf(s, "*** %s has left.\n", p->nick);
	    sendconsole(s);
	}
	free(p);
    }
    delconsole(sock->fd);
    return;
}

void initconsole(int port) {
    int ret, sid;
    printf("*** Console ***\n");
    ret=socket_create(SOCKTYPE_LISTEN, 0, console_onconnect, console_ondisconnect, console_onrecv, console_onclose, console_onerror);
    if (ret < 0) FATALERROR1("initconsole(%d): socket_create\n", port);
    sid=ret;
    ret=socket_bind(sid, "0.0.0.0", port);
    if (!ret) FATALERROR1("initconsole(%d): socket_bind\n", port);
    ret=socket_listen(sid, 4);
    if (ret < 0) FATALERROR1("initconsole(%d): socket_listen\n", port);
    ret=addcall(&calls, CALL_CONSOLE);
    if (!ret) FATALERROR1("initconsole(%d): addcall\n", port);
    ret=addcallidlist(&calls, CALL_CONSOLE, (struct scalllistlist *) &callcon);
    if (!ret) FATALERROR1("initconsole(%d): addcallidlist\n", port);
    printf("Listen port:     %d\n", port);
    printf("Auth type:       plaintext\n");
}

int addconsole(int fd) {
    struct sconsole *p;
    p=(struct sconsole *) malloc(sizeof(struct sconsole));
    p->fd=fd;
    if (console == NULL) {
	console=p;
	p->next=NULL;
    } else {
	p->next=console;
	console=p;
    }
    return 1;
}

int delconsole(int fd) {
    struct sconsole *p, *lp;
    lp=NULL;
    p=console;
    while (p) {
	if (p->fd == fd) {
	    if (lp) {
		lp->next=p->next;
		free(p);
	    } else {
		console=p->next;
		free(p);
	    }
	    return 1;
	}
	lp=p;
	p=p->next;
    }
    return 0;
}

int freeconsole() {
    struct sconsole *p, *lp;
    p=console;
    while (p) {
	lp=p;
	p=p->next;
	free(lp);
    }
    return 0;
}

int sendconsole(char *s) {
    struct sconsole *p;
    p=console;
    while (p) {
	dprintf(p->fd, "%s", s);
	p=p->next;
    }
    return 0;
}
