#define MAXSOCKETS 			48
#define INBUFSIZE			16384

#define SOCKTYPE_FREE			0x0000
#define SOCKTYPE_NORMAL			0x0001
#define SOCKTYPE_LISTEN			0x0002
#define SOCKTYPE_NORMAL6		0x0003
#define SOCKTYPE_ACCEPT			0x0004

#define SOCKNORMAL_NONE			0x0000
#define SOCKNORMAL_CONNECT		0x0001
#define SOCKNORMAL_CONNECTED		0x0002
#define SOCKNORMAL_CONNECTERROR		0x0003
#define SOCKNORMAL_DISCONNECTED		0x0004

#define SOCKLISTEN_NONE			0x0000
#define SOCKLISTEN_LISTEN		0x0001

#define SOCKACCEPT_NONE			0x0000
#define SOCKACCEPT_CONNECTED		0x0001
#define SOCKACCEPT_DISCONNECTED         0x0002

struct ssock {
    int fd;
    int psid;
    int type;
    int status;
    int errorno;
    struct sockaddr_in sin;
    struct sockaddr_in6 sin6;
    char *inbuf;
    char *special;
    Function onconnect;
    Function ondisconnect;
    Function onrecv;
    Function onclose;
    Function onerror;
};

struct ssock socktab[MAXSOCKETS];

char *socketerror(int err);
struct in6_addr inet_addr6(char *addr);
void initnet();
int socket_create(int type, int psid, Function onconnect, Function ondisconnect, Function onrecv, Function onclose, Function onerror);
int socket_bind(int sid, char *addr, int port);
int socket_connect(int sid, char *addr, int port);
int socket_listen(int sid, int max);
int socket_accept(int psid);
int socket_closeid(int sid);
int socket_closefd(int fd);
int socket_idle();
