struct shandle *userlist;

void freeuserlist(struct shandle **ul) {
    struct shandle *p, *pt;
    struct shostlist *h, *ht;
    p=*ul;
    while (p) {
	if (p->handle) free(p->handle);
	if (p->pass) free(p->pass);
	h=p->hostlist;
	while (h) {
	    if (h->host) free(h->host);
	    ht=h;
	    h=h->next;
	    free(ht);
	}
	pt=p;
	p=p->next;
	free(pt);
    }
    *ul=NULL;
}

int ulfgets(char enc, char *s, int maxlen, FILE *f) {
    int i;
    if (enc == 0x00) {
	if (fgets(s, maxlen, f)) return 1; else return 0;
    } else if (enc == 0x01) {
    } else return 0;
}

int ulload(char *fn) {
    FILE *f;
    int i;
    char ver, enc;
    char ss[2048];
    char *s=ss;
    char *s2;
    char idx;
    struct shandle *hand;
    struct shostlist *h;
    if (!fn) return 0;
    if (!fn[0]) return 0;
    f=fopen(fn, "r");
    if (!f) return 0;
    if (ver=fgetc(f) == EOF) return 0;
    if (ver == 0x00) {
	if (enc=fgetc(f) == EOF) return 0;
	if (userlist) freeuserlist(&userlist);
	while (ulfgets(enc, s, 2048, f)) {
	    if (s[strlen(s)-1] == '\n') s[strlen(s)-1]=0;
	    hand=(struct shandle *) malloc(sizeof(struct shandle));
	    s2=newsplit(&s);
	    if (!strlen(s2) || (strlen(s2) > MAXHANDLELEN)) { fclose(f); return 0; }
	    hand->handle=(char *) malloc(strlen(s2)+1);
	    strcpy(hand->handle, s2);
	    s2=newsplit(&s);
	    if (!strlen(s2) || (strlen(s2) > MAXPASSLEN)) { fclose(f); return 0; }
	    hand->pass=(char *) malloc(strlen(s2)+1);
	    strcpy(hand->pass, s2);
	    s2=newsplit(&s);
	    if (strlen(s2) > 64) { fclose(f); return 0; }
	    for (i=0; i < 64; i++) hand->flags[i]=0;
	    i=0;
	    while (s2[i]) {
		if ((unsigned char) s2[i] > 127) return 0;
		idx=flaglist[s2[i]];
		if (idx && (idx < 64)) hand->flags[idx-1]=1;
		i++;
	    }
	    hand->hostlist=NULL;
	    s2=newsplit(&s);
	    while (strlen(s2)) {
		h=(struct shostlist *) malloc(sizeof(struct shostlist));
		h->host=(char *) malloc(strlen(s2)+1);
		strcpy(h->host, s2);
		h->next=hand->hostlist;
		hand->hostlist=h;
		s2=newsplit(&s);
	    }
	    if (userlist) hand->next=userlist; else hand->next=NULL;
	    userlist=hand;
	}
	fclose(f);
	return 1;
    }
    return 0;
}

int ulsave(char *fn) {
    FILE *f;
    int i;
    char ver, enc;
    struct shandle *hand;
    struct shostlist *h;
    if (userlist == NULL) return 0;
    ver=0x00; enc=0x00;
    if (!fn) return 0;
    if (!fn[0]) return 0;
    f=fopen(fn, "w");
    fprintf(f, "%c%c", ver, enc);
    hand=userlist;
    while (hand) {
	if (hand->handle == NULL) continue;
	fprintf(f, "%s ", hand->handle);
	if (hand->pass) fprintf(f, "%s ", hand->pass); else fprintf(f, "*");
	for (i=0; i < 64; i++)
	    if (hand->flags[i]) fprintf(f, "%c", flaglistrev[i]);
	h=hand->hostlist;
	while (h) {
	    if (h->host) fprintf(f, " %s", h->host);
	    h=h->next;
	}
	fprintf(f, "\n");
	hand=hand->next;
    }
    fclose(f);
}

struct shandle *ulfindhandle(char *handle) {
    struct shandle *hand;
    hand=userlist;
    while (hand) {
	if (strcasecmp(handle, hand->handle) == 0) return hand;
	hand=hand->next;
    }
    return NULL;
}

struct shandle *ulfindhandlehost(char *host) {
    struct shandle *hand;
    struct shostlist *h;
    hand=userlist;
    while (hand) {
	h=hand->hostlist;
	while (h) {
	    if (matchmask(host, h->host)) return hand;
	    h=h->next;
	}
	hand=hand->next;
    }
    return NULL;
}

struct shandle *uladduser(char *nick) {
    struct shandle *hand;
    int i;
    if (!nick && !nick[0]) return NULL;
    if (ulfindhandle(nick)) return NULL;
    hand=(struct shandle *) malloc(sizeof(struct shandle));
    if (!strlen(nick) || (strlen(nick) > MAXHANDLELEN)) return NULL;
    hand->handle=(char *) malloc(strlen(nick)+1);
    strcpy(hand->handle, nick);
    hand->pass=NULL;
    for (i=0; i < 64; i++) hand->flags[i]=0;
    hand->hostlist=NULL;
    if (userlist) hand->next=userlist; else hand->next=NULL;
    userlist=hand;
    return hand;
}

int uldeluser(char *nick) {
    struct shandle *hand, *lhand;
    struct shostlist *h, *ht;
    int i;
    if (!nick && !nick[0]) return 0;
    lhand=NULL;
    hand=userlist;
    while (hand) {
	if (strcasecmp(nick, hand->handle) == 0) {
	    if (hand->handle) free(hand->handle);
	    if (hand->pass) free(hand->pass);
	    h=hand->hostlist;
	    while (h) {
		if (h->host) free(h->host);
		ht=h;
		h=h->next;
		free(ht);
	    }
	    if (lhand) {
		lhand->next=hand->next;
		free(hand);
	    } else {
		userlist=hand->next;
		free(hand);
	    }
	    return 1;
	}
	hand=hand->next;
	if (lhand) lhand=lhand->next; else lhand=userlist;
    } 
    return 0;
}

int ulchattruser(char *nick, char *attr) {
    struct shandle *hand;
    int i, idx;
    int pm=1;
    if (!nick && !nick[0]) return 0;
    hand=ulfindhandle(nick);
    if (!hand) return 0;
    i=0;
    while (attr[i]) {
	if ((unsigned char) attr[i] > 127) return 0;
	if (attr[i] == '+') pm=1;
	else if (attr[i] == '-') pm=0;
	else {
	    idx=flaglist[attr[i]];
	    if (idx && (idx < 64)) hand->flags[idx-1]=pm;
	}
	i++;
    }
    return 1;
}

int ulchpassuser(char *nick, char *pass) {
    struct shandle *hand;
    if (!nick && !nick[0]) return 0;
    hand=ulfindhandle(nick);
    if (!hand) return 0;
    if (hand->pass) free(hand->pass);
    hand->pass=(char *) malloc(strlen(pass)+1);
    strcpy(hand->pass, pass);
    return 1;
}

int uladdhost(char *nick, char *host) {
    struct shandle *hand;
    struct shostlist *h;
    int i;
    if (!nick && !nick[0]) return 0;
    if (!host && !host[0]) return 0;
    hand=ulfindhandle(nick);
    if (!hand) return 0;
    h=(struct shostlist *) malloc(sizeof(struct shostlist));
    h->host=(char *) malloc(strlen(host)+1);
    strcpy(h->host, host);
    h->next=hand->hostlist;
    hand->hostlist=h;
    return 1;
}

int uldelhost(char *nick, char *host) {
    struct shandle *hand;
    struct shostlist *h, *lh;
    int i;
    if (!nick && !nick[0]) return 0;
    if (!host && !host[0]) return 0;
    hand=ulfindhandle(nick);
    if (!hand) return 0;
    lh=NULL;
    h=hand->hostlist;
    while (h) {
	if (strcasecmp(host, h->host) == 0) {
	    if (h->host) free(h->host);
	    if (lh) {
		lh->next=h->next;
		free(h);
	    } else {
		hand->hostlist=h->next;
		free(h);
	    }
	    return 1;
	}
	h=h->next;
	if (lh) lh=lh->next; else lh=hand->hostlist;
    }
    return 0;
}

int ulprinthandle(int fd, char *nick) {
    struct shandle *hand;
    struct shostlist *h;
    char attr[65];
    char pad[64];
    int i, isfirst, hlen;
    if (!nick && !nick[0]) return 0;
    hand=ulfindhandle(nick);
    if (!hand) return 0;
    attr[0]=0;
    for (i=0; i < 64; i++) if (hand->flags[i]) sprintf(attr, "%s%c", attr, flaglistrev[i]);
    for (i=0; i < 64; i++) pad[i]=' ';
    pad[63]=0;
    pad[MAXHANDLELEN-strlen(hand->handle)]=0;
    dprintf(fd, "HANDLE           PASS  FLAGS\n");
    dprintf(fd, "%s%s %s   %s\n", hand->handle, pad, hand->pass?"yes":"no ", attr);
    dprintf(fd, "  HOSTS: ");
    isfirst=1;
    h=hand->hostlist;
    while (h) {
	if (isfirst) {
	    isfirst=0;
	    dprintf(fd, "%s", h->host);
	    hlen=strlen(h->host);
	} else {
	    if ((hlen+strlen(h->host)+2) > 70) {
		dprintf(fd, ",\n         %s", h->host);
		hlen=0;
	    } else dprintf(fd, ", %s", h->host);
	    hlen+=strlen(h->host)+2;
	}
	h=h->next;
    }
    dprintf(fd, "\n");
    return 0;
}

int ULMATCHFLAG(struct shandle *hand, char flag) {
    if (hand) return hand->flags[flaglist[flag]-1];
    return 0;
}
